diff --git a/Makefile b/Makefile
index df41642..f2f17c8 100644
--- a/Makefile
+++ b/Makefile
@@ -46,18 +46,10 @@ kver_lt = $(shell [ $(KMAJ) -lt $(1) -o \
 	$(KMAJ) -eq $(1) -a $(KMIN) -lt $(2) -o \
         $(KMAJ) -eq $(1) -a $(KMIN) -eq $(2) -a $(KREV) -lt $(3) ] && \
 	echo 1 || echo 0)
-kver_le = $(shell [ $(KMAJ) -lt $(1) -o \
-        $(KMAJ) -eq $(1) -a $(KMIN) -lt $(2) -o \
-        $(KMAJ) -eq $(1) -a $(KMIN) -eq $(2) -a $(KREV) -le $(3) ] && \
-	echo 1 || echo 0)
-kver_gt = $(shell [ ( $(KMAJ) -gt $(1) ) -o \
+kver_gt = $(shell [ $(KMAJ) -gt $(1) -o \
         $(KMAJ) -eq $(1) -a $(KMIN) -gt $(2) -o \
         $(KMAJ) -eq $(1) -a $(KMIN) -eq $(2) -a $(KREV) -gt $(3) ] && \
 	echo 1 || echo 0)
-kver_ge = $(shell [ ( $(KMAJ) -gt $(1) ) -o \
-        $(KMAJ) -eq $(1) -a $(KMIN) -gt $(2) -o \
-        $(KMAJ) -eq $(1) -a $(KMIN) -eq $(2) -a $(KREV) -ge $(3) ] && \
-	echo 1 || echo 0)
 kver_lk = $(shell [ `echo $(KVER) | egrep $(1)` ] && echo 1 || echo 0)
 
 #
@@ -66,85 +58,93 @@ kver_lk = $(shell [ `echo $(KVER) | egrep $(1)` ] && echo 1 || echo 0)
 # base first the earlier patch sets will not need to be modified.
 #
 
-ifeq ($(call kver_le,3,5,0),1)
+ifeq ($(call kver_lt,3,6,0),1)
 	PATCHES := $(PATCHES) compat-3.5.patch
 endif
 
-ifeq ($(call kver_le,3,4,0),1)
+ifeq ($(call kver_lt,3,5,0),1)
 	PATCHES := $(PATCHES) compat-3.2-3.4.patch
 endif
 
-ifeq ($(call kver_le,3,2,0),1)
+ifeq ($(call kver_lt,3,3,0),1)
 	PATCHES := $(PATCHES) compat-2.6.39-3.2.patch
 endif
 
-ifeq ($(call kver_le,2,6,38),1)
+ifeq ($(call kver_lt,2,6,39),1)
 	PATCHES := $(PATCHES) compat-2.6.38.patch
 endif
 
-ifeq ($(call kver_le,2,6,37),1)
+ifeq ($(call kver_lt,2,6,38),1)
 	PATCHES := $(PATCHES) compat-2.6.36-2.6.37.patch
 endif
 
 # Compatibility patch for kernels > 2.6.32 <= 2.6.35
-ifeq ($(call kver_le,2,6,35),1)
+ifeq ($(call kver_lt,2,6,36),1)
+ifeq ($(call kver_gt,2,6,32),1)
 	PATCHES := $(PATCHES) compat-2.6.33-2.6.35.patch
 endif
+endif
 
 # Compatibility patch for kernels <= 2.6.32
-ifeq ($(call kver_le,2,6,32),1)
+ifeq ($(call kver_lt,2,6,33),1)
 	PATCHES := $(PATCHES) compat-2.6.32.patch
 endif
 
 # Compatibility patch for kernels <= 2.6.31
-ifeq ($(call kver_le,2,6,31),1)
+ifeq ($(call kver_lt,2,6,32),1)
 	PATCHES := $(PATCHES) compat-2.6.31.patch
 endif
 
 # Compatibility patch for kernels <= 2.6.30
-ifeq ($(call kver_le,2,6,30),1)
+ifeq ($(call kver_lt,2,6,31),1)
 	PATCHES := $(PATCHES) compat-2.6.30.patch
 endif
 
 # Compatibility patch for kernels <= 2.6.29
-ifeq ($(call kver_le,2,6,29),1)
+ifeq ($(call kver_lt,2,6,30),1)
 	PATCHES := $(PATCHES) compat-2.6.29.patch
 endif
 
 # Compatibility patch for kernels <= 2.6.28
-ifeq ($(call kver_le,2,6,28),1)
+ifeq ($(call kver_lt,2,6,29),1)
 	PATCHES := $(PATCHES) compat-2.6.28.patch
 endif
 
 # Compatibility patch for kernels >= 2.6.25 and <= 2.6.27
-ifeq ($(call kver_le,2,6,27),1)
+ifeq ($(call kver_lt,2,6,28),1)
+ifeq ($(call kver_gt,2,6,24),1)
 	PATCHES := $(PATCHES) compat-2.6.25-2.6.27.patch
 endif
+endif
 
 # Compatibility patch for kernels <= 2.6.24
-ifeq ($(call kver_le,2,6,24),1)
+ifeq ($(call kver_lt,2,6,25),1)
 	PATCHES := $(PATCHES) compat-2.6.24.patch
 endif
 
 # Compatibility patch for kernels <= 2.6.23
-ifeq ($(call kver_le,2,6,23),1)
+ifeq ($(call kver_lt,2,6,24),1)
 	PATCHES := $(PATCHES) compat-2.6.23.patch
 endif
 
 # Compatibility patch for kernels <= 2.6.22
-ifeq ($(call kver_le,2,6,22),1)
+ifeq ($(call kver_lt,2,6,23),1)
 	PATCHES := $(PATCHES) compat-2.6.22.patch
 endif
 
 # Compatibility patch for kernels >= 2.6.19 and <= 2.6.21
-ifeq ($(call kver_le,2,6,21),1)
+ifeq ($(call kver_lt,2,6,22),1)
+ifeq ($(call kver_gt,2,6,18),1)
 	PATCHES := $(PATCHES) compat-2.6.19-2.6.21.patch
 endif
+endif
 
 # Compatibility patch for kernels >= 2.6.14 and <= 2.6.18
-ifeq ($(call kver_le,2,6,18),1)
+ifeq ($(call kver_lt,2,6,19),1)
+ifeq ($(call kver_gt,2,6,13),1)
 	PATCHES := $(PATCHES) compat-2.6.14-2.6.18.patch
 endif
+endif
 
 # We don't support kernels < 2.6.14 except for explicit distros
 ifeq ($(call kver_lt,2,6,14),1)
